
!--------------------------------------------------------------------------
!
!    Copyright (C) 1985-2018  Georg Umgiesser
!
!    This file is part of SHYFEM.
!
!    SHYFEM is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SHYFEM is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SHYFEM. Please see the file COPYING in the main directory.
!    If not, see <http://www.gnu.org/licenses/>.
!
!    Contributions to this file can be found below in the revision log.
!
!--------------------------------------------------------------------------

! revision log :
!
! 24.01.2018	ggu	changed VERS_7_5_41
! 16.02.2019	ggu	changed VERS_7_5_60
! 21.05.2019	ggu	changed VERS_7_5_62

!******************************************************************
!******************************************************************
!******************************************************************

        subroutine count_buffer(n0,nlvddi,n,nc,il,nodes,nb)

        integer n0,nlvddi,n,nc
        integer il(n)
        integer nodes(nc)
        integer nb

        integer i,k,l,lmax

        if( nlvddi == 1 ) then
          nb = nc * (2-n0)
        else
          nb = 0
          do i=1,nc
            k = nodes(i)
            lmax = il(k)
            nb = nb + lmax - n0 + 1
          end do
        end if

        end subroutine count_buffer

!******************************************************************

        subroutine to_buffer_i(n0,nlvddi,n,nc,il,nodes,val,nb,buffer)

        integer n0,nlvddi,n,nc
        integer il(n)
        integer nodes(nc)
        integer val(n0:nlvddi,n)
        integer nb
        integer buffer(nb)

        integer i,k,l,lmax

        if( nlvddi == 1 .and. n0 == 1 ) then
          do i=1,nc
            k = nodes(i)
            buffer(i) = val(1,k)
          end do
          nb = nc
        else
          nb = 0
          do i=1,nc
            k = nodes(i)
            lmax = il(k)
            do l=n0,lmax
              nb = nb + 1
              buffer(nb) = val(l,k)
            end do
          end do
        end if

        end subroutine to_buffer_i

!******************************************************************

        subroutine from_buffer_i(n0,nlvddi,n,nc,il,nodes,val,nb,buffer)

        integer n0,nlvddi,n,nc
        integer il(n)
        integer nodes(nc)
        integer val(n0:nlvddi,n)
        integer nb
        integer buffer(nb)

        integer i,k,l,lmax

        if( nlvddi == 1 .and. n0 == 1 ) then
          do i=1,nc
            k = nodes(i)
            val(1,k) = buffer(i)
          end do
          nb = nc
        else
          nb = 0
          do i=1,nc
            k = nodes(i)
            lmax = il(k)
            do l=n0,lmax
              nb = nb + 1
              val(l,k) = buffer(nb)
            end do
          end do
        end if

        end subroutine from_buffer_i

!******************************************************************

        subroutine to_buffer_r(n0,nlvddi,n,nc,il,nodes,val,nb,buffer)

        integer n0,nlvddi,n,nc
        integer il(n)
        integer nodes(nc)
        real val(n0:nlvddi,n)
        integer nb
        real buffer(nb)

        integer i,k,l,lmax

        if( nlvddi == 1 .and. n0 == 1 ) then
          do i=1,nc
            k = nodes(i)
            buffer(i) = val(1,k)
          end do
          nb = nc
        else
          nb = 0
          do i=1,nc
            k = nodes(i)
            lmax = il(k)
            do l=n0,lmax
              nb = nb + 1
              buffer(nb) = val(l,k)
            end do
          end do
        end if

        end subroutine to_buffer_r

!******************************************************************

        subroutine from_buffer_r(n0,nlvddi,n,nc,il,nodes,val,nb,buffer)

        integer n0,nlvddi,n,nc
        integer il(n)
        integer nodes(nc)
        real val(n0:nlvddi,n)
        integer nb
        real buffer(nb)

        integer i,k,l,lmax

        if( nlvddi == 1 .and. n0 == 1 ) then
          do i=1,nc
            k = nodes(i)
            val(1,k) = buffer(i)
          end do
          nb = nc
        else
          nb = 0
          do i=1,nc
            k = nodes(i)
            lmax = il(k)
            do l=n0,lmax
              nb = nb + 1
              val(l,k) = buffer(nb)
            end do
          end do
        end if

        end subroutine from_buffer_r

!******************************************************************
!******************************************************************
!******************************************************************

