!-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
! MODEL
!	   BFM - Biogeochemical Flux Model version 2.50-g
!
! MODULE
!   set_var_info_bfm
!
! FILE
!   set_var_info_bfm
!
! DESCRIPTION
!  This subroutine provides information on the variables. To be used
!  when storing data in NetCDF files.

!  This file is produced by a procedure from a file which include all
!  definitions of global variables and state variables  and a proto-file 
!
!
! AUTHORS
!    Piet Ruardij
!
! CHANGE_LOG
!   ---
!
! COPYING
!   
!   Copyright (C) 2006 P. Ruardij, 
!
!   This program is free software; you can redistribute it and/or modify
!   it under the terms of the GNU General Public License as published by
!   the Free Software Foundation;
!   This program is distributed in the hope that it will be useful,
!   but WITHOUT ANY WARRANTY; without even the implied warranty of
!   MERCHANTEABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!   GNU General Public License for more details.
!
!-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
!
!
!

subroutine set_var_info_bfm

#ifdef BFM_GOTM
  use mem
  use bio_var, only: var_names,var_long,var_units
  use bio_var, only: stPelStateS,stPelDiagS,stPelFluxS,stBenStateS,stBenDiagS,stBenFluxS
  use bio_var, only: stPelStateE,stPelDiagE,stPelFluxE,stBenStateE,stBenDiagE,stBenFluxE
#else
  use api_bfm
#endif
 




!
! 3d variables descriptions:
!
        var_names(1)="O2o"
        var_long(1)="Oxgen"
        var_units(1)="mmol O2/m3"
        var_names(2)="N1p"
        var_long(2)="Phosphate"
        var_units(2)="mmol P/m3"
        var_names(3)="N3n"
        var_long(3)="Nitrate"
        var_units(3)="mmol N/m3"
        var_names(4)="N4n"
        var_long(4)="Ammonium"
        var_units(4)="mmol N/m3"
        var_names(5)="O4n"
        var_long(5)="NitrogenSink"
        var_units(5)="mmol N/m3"
        var_names(6)="N5s"
        var_long(6)="Silicate"
        var_units(6)="mmol Si/m3"
        var_names(7)="N6r"
        var_long(7)="Reduction Equivalents"
        var_units(7)="mmol S--/m3"
        var_names(8)="B1c"
        var_long(8)="Pelagic Bacteria"
        var_units(8)="mg C/m3"
        var_names(9)="B1n"
        var_long(9)="Pelagic Bacteria"
        var_units(9)="mmol N/m3"
        var_names(10)="B1p"
        var_long(10)="Pelagic Bacteria"
        var_units(10)="mmol P/m3"
        var_names(11)="P1c"
        var_long(11)="Diatoms"
        var_units(11)="mg C/m3"
        var_names(12)="P1n"
        var_long(12)="Diatoms"
        var_units(12)="mmol N/m3"
        var_names(13)="P1p"
        var_long(13)="Diatoms"
        var_units(13)="mmol P/m3"
        var_names(14)="P1l"
        var_long(14)="Diatoms"
        var_units(14)="mg Chl/m3"
        var_names(15)="P1s"
        var_long(15)="Diatoms"
        var_units(15)="mmmol Si/m3"
        var_names(16)="P2c"
        var_long(16)="Flagellates"
        var_units(16)="mg C/m3"
        var_names(17)="P2n"
        var_long(17)="Flagellates"
        var_units(17)="mmol N/m3"
        var_names(18)="P2p"
        var_long(18)="Flagellates"
        var_units(18)="mmol P/m3"
        var_names(19)="P2l"
        var_long(19)="Flagellates"
        var_units(19)="mg Chl/m3"
        var_names(20)="P3c"
        var_long(20)="PicoPhytoPlankton"
        var_units(20)="mg C/m3"
        var_names(21)="P3n"
        var_long(21)="PicoPhytoPlankton"
        var_units(21)="mmol N/m3"
        var_names(22)="P3p"
        var_long(22)="PicoPhytoPlankton"
        var_units(22)="mmol P/m3"
        var_names(23)="P3l"
        var_long(23)="PicoPhytoPlankton"
        var_units(23)="mg Chl/m3"
        var_names(24)="P4c"
        var_long(24)="Dinoflagellates"
        var_units(24)="mg C/m3"
        var_names(25)="P4n"
        var_long(25)="Dinoflagellates"
        var_units(25)="mmol N/m3"
        var_names(26)="P4p"
        var_long(26)="Dinoflagellates"
        var_units(26)="mmol P/m3"
        var_names(27)="P4l"
        var_long(27)="Dinoflagellates"
        var_units(27)="mg Chl/m3"
        var_names(28)="Z3c"
        var_long(28)="Carnivorous mesozooplankton"
        var_units(28)="mg C/m3"
        var_names(29)="Z3n"
        var_long(29)="Carnivorous mesozooplankton"
        var_units(29)="mmol N/m3"
        var_names(30)="Z3p"
        var_long(30)="Carnivorous mesozooplankton"
        var_units(30)="mmol P/m3"
        var_names(31)="Z4c"
        var_long(31)="Omnivorous mesozooplankton"
        var_units(31)="mg C/m3"
        var_names(32)="Z4n"
        var_long(32)="Omnivorous mesozooplankton"
        var_units(32)="mmol N/m3"
        var_names(33)="Z4p"
        var_long(33)="Omnivorous mesozooplankton"
        var_units(33)="mmol P/m3"
        var_names(34)="Z5c"
        var_long(34)="Microzooplankton"
        var_units(34)="mg C/m3"
        var_names(35)="Z5n"
        var_long(35)="Microzooplankton"
        var_units(35)="mmol N/m3"
        var_names(36)="Z5p"
        var_long(36)="Microzooplankton"
        var_units(36)="mmol P/m3"
        var_names(37)="Z6c"
        var_long(37)="Heterotrophic nanoflagellates (HNAN)"
        var_units(37)="mg C/m3"
        var_names(38)="Z6n"
        var_long(38)="Heterotrophic nanoflagellates (HNAN)"
        var_units(38)="mmol N/m3"
        var_names(39)="Z6p"
        var_long(39)="Heterotrophic nanoflagellates (HNAN)"
        var_units(39)="mmol P/m3"
        var_names(40)="R1c"
        var_long(40)="Labile Organic Carbon (LOC)"
        var_units(40)="mg C/m3"
        var_names(41)="R1n"
        var_long(41)="Labile Organic Carbon (LOC)"
        var_units(41)="mmol N/m3"
        var_names(42)="R1p"
        var_long(42)="Labile Organic Carbon (LOC)"
        var_units(42)="mmol P/m3"
        var_names(43)="R2c"
        var_long(43)="CarboHydrates (sugars)"
        var_units(43)="mg C/m3"
        var_names(44)="R6c"
        var_long(44)="Particulate Organic Carbon (POC)"
        var_units(44)="mg C/m3"
        var_names(45)="R6n"
        var_long(45)="Particulate Organic Carbon (POC)"
        var_units(45)="mmol N/m3"
        var_names(46)="R6p"
        var_long(46)="Particulate Organic Carbon (POC)"
        var_units(46)="mmol P/m3"
        var_names(47)="R6s"
        var_long(47)="Particulate Organic Carbon (POC)"
        var_units(47)="mmmol Si/m3"
        var_names(48)="R7c"
        var_long(48)="Refractory DOC"
        var_units(48)="mg C/m3"
 
        var_names(49)="ETW"
        var_long(49)="temperature"
        var_units(49)="C"
        var_names(50)="ESW"
        var_long(50)="Salinity"
        var_units(50)="--"
        var_names(51)="EIR"
        var_long(51)="Irradiance"
        var_units(51)="W/m2"
        var_names(52)="ESS"
        var_long(52)="Suspended sediment"
        var_units(52)="g/m3"
        var_names(53)="cxoO2"
        var_long(53)="Temperature-dependent oxygen saturation"
        var_units(53)="mmol O2/m3"
        var_names(54)="XO2o"
        var_long(54)="Net O2 conc. = O2 - H2S"
        var_units(54)="mmol O2/m3"
        var_names(55)="eO2mO2"
        var_long(55)="Relative Oxygen saturation"
        var_units(55)="%"
        var_names(56)="Chla"
        var_long(56)="Chlorophyl"
        var_units(56)="mg Chl/m3"
        var_names(57)="flP1R6s"
        var_long(57)="part. silica flux"
        var_units(57)="mmol Si /m3"
        var_names(58)="flPTN6r"
        var_long(58)="anaerobic mineralixation"
        var_units(58)="mmol S--/m3"
        var_names(59)="flN3O4n"
        var_long(59)="denitrification flux (sink)"
        var_units(59)="mmol N/m3/d"
        var_names(60)="qpR6c"
        var_long(60)="Quotum p/c in R6"
        var_units(60)="mmol N/mg C"
        var_names(61)="qnR6c"
        var_long(61)="Quotum n/c in R6"
        var_units(61)="mmol P/mg C"
        var_names(62)="qsR6c"
        var_long(62)="Quotum si/c in R6"
        var_units(62)="mmol Si/mg C"
        var_names(63)="qpB1c"
        var_long(63)="Quotum p/c in B1"
        var_units(63)="mmol N/mg C"
        var_names(64)="qnB1c"
        var_long(64)="Quotum n/c in B1"
        var_units(64)="mmol P/mg C"
        var_names(65)="sediR6"
        var_long(65)="Detritus sedimentation rate"
        var_units(65)="m/d"
        var_names(66)="xEPS"
        var_long(66)="Total extinction coefficient"
        var_units(66)="1/m"
  
        var_names(67)="sunPI(iiP1)"
        var_long(67)="Specific Net Prod. P1(PhytoPlankton)"
        var_units(67)="mgC/mgC/day"
        var_names(68)="sunPI(iiP2)"
        var_long(68)="Specific Net Prod. P2(PhytoPlankton)"
        var_units(68)="mgC/mgC/day"
        var_names(69)="sunPI(iiP3)"
        var_long(69)="Specific Net Prod. P3(PhytoPlankton)"
        var_units(69)="mgC/mgC/day"
        var_names(70)="sunPI(iiP4)"
        var_long(70)="Specific Net Prod. P4(PhytoPlankton)"
        var_units(70)="mgC/mgC/day"
        var_names(71)="qpPc(iiP1)"
        var_long(71)="Quotum p/c in P1(PhytoPlankton)"
        var_units(71)="mmol P/mg C"
        var_names(72)="qpPc(iiP2)"
        var_long(72)="Quotum p/c in P2(PhytoPlankton)"
        var_units(72)="mmol P/mg C"
        var_names(73)="qpPc(iiP3)"
        var_long(73)="Quotum p/c in P3(PhytoPlankton)"
        var_units(73)="mmol P/mg C"
        var_names(74)="qpPc(iiP4)"
        var_long(74)="Quotum p/c in P4(PhytoPlankton)"
        var_units(74)="mmol P/mg C"
        var_names(75)="qnPc(iiP1)"
        var_long(75)="Quotum n/c in P1(PhytoPlankton)"
        var_units(75)="mmol N/mg C"
        var_names(76)="qnPc(iiP2)"
        var_long(76)="Quotum n/c in P2(PhytoPlankton)"
        var_units(76)="mmol N/mg C"
        var_names(77)="qnPc(iiP3)"
        var_long(77)="Quotum n/c in P3(PhytoPlankton)"
        var_units(77)="mmol N/mg C"
        var_names(78)="qnPc(iiP4)"
        var_long(78)="Quotum n/c in P4(PhytoPlankton)"
        var_units(78)="mmol N/mg C"
        var_names(79)="qsPc(iiP1)"
        var_long(79)="Quotum si/c in P1(PhytoPlankton)"
        var_units(79)="mmol Si/mg C"
        var_names(80)="qsPc(iiP2)"
        var_long(80)="Quotum si/c in P2(PhytoPlankton)"
        var_units(80)="mmol Si/mg C"
        var_names(81)="qsPc(iiP3)"
        var_long(81)="Quotum si/c in P3(PhytoPlankton)"
        var_units(81)="mmol Si/mg C"
        var_names(82)="qsPc(iiP4)"
        var_long(82)="Quotum si/c in P4(PhytoPlankton)"
        var_units(82)="mmol Si/mg C"
        var_names(83)="qlPc(iiP1)"
        var_long(83)="Quotum chl/c in P1(PhytoPlankton)"
        var_units(83)="mg Chl /mg C"
        var_names(84)="qlPc(iiP2)"
        var_long(84)="Quotum chl/c in P2(PhytoPlankton)"
        var_units(84)="mg Chl /mg C"
        var_names(85)="qlPc(iiP3)"
        var_long(85)="Quotum chl/c in P3(PhytoPlankton)"
        var_units(85)="mg Chl /mg C"
        var_names(86)="qlPc(iiP4)"
        var_long(86)="Quotum chl/c in P4(PhytoPlankton)"
        var_units(86)="mg Chl /mg C"
        var_names(87)="qpZc(iiZ3)"
        var_long(87)="Quotum p/c Z3(MesoZooPlankton)"
        var_units(87)="mmol P/mg C"
        var_names(88)="qpZc(iiZ4)"
        var_long(88)="Quotum p/c Z4(MesoZooPlankton)"
        var_units(88)="mmol P/mg C"
        var_names(89)="qnZc(iiZ3)"
        var_long(89)="Quotum n/c Z3(MesoZooPlankton)"
        var_units(89)="mmol N/mg C"
        var_names(90)="qnZc(iiZ4)"
        var_long(90)="Quotum n/c Z4(MesoZooPlankton)"
        var_units(90)="mmol N/mg C"
        var_names(91)="qp_mz(iiZ5)"
        var_long(91)="Quotum p/c Z5(MicroZooPlankton)"
        var_units(91)="mmol P/mg C"
        var_names(92)="qp_mz(iiZ6)"
        var_long(92)="Quotum p/c Z6(MicroZooPlankton)"
        var_units(92)="mmol P/mg C"
        var_names(93)="qn_mz(iiZ5)"
        var_long(93)="Quotum n/c Z5(MicroZooPlankton)"
        var_units(93)="mmol N/mg C"
        var_names(94)="qn_mz(iiZ6)"
        var_long(94)="Quotum n/c Z6(MicroZooPlankton)"
        var_units(94)="mmol N/mg C"
        var_names(95)="sediPI(iiP1)"
        var_long(95)="P1(PhytoPlankton) sedimentation rate"
        var_units(95)="m/d"
        var_names(96)="sediPI(iiP2)"
        var_long(96)="P2(PhytoPlankton) sedimentation rate"
        var_units(96)="m/d"
        var_names(97)="sediPI(iiP3)"
        var_long(97)="P3(PhytoPlankton) sedimentation rate"
        var_units(97)="m/d"
        var_names(98)="sediPI(iiP4)"
        var_long(98)="P4(PhytoPlankton) sedimentation rate"
        var_units(98)="m/d"
        var_names(99)="eiPI(iiP1)"
        var_long(99)="Regulating factor for light in P1(PhytoPlankton)"
        var_units(99)="-"
        var_names(100)="eiPI(iiP2)"
        var_long(100)="Regulating factor for light in P2(PhytoPlankton)"
        var_units(100)="-"
        var_names(101)="eiPI(iiP3)"
        var_long(101)="Regulating factor for light in P3(PhytoPlankton)"
        var_units(101)="-"
        var_names(102)="eiPI(iiP4)"
        var_long(102)="Regulating factor for light in P4(PhytoPlankton)"
        var_units(102)="-"
        var_names(103)="EPLi(iiP1)"
        var_long(103)="Optimal light in P1(PhytoPlankton)"
        var_units(103)="W/m2"
        var_names(104)="EPLi(iiP2)"
        var_long(104)="Optimal light in P2(PhytoPlankton)"
        var_units(104)="W/m2"
        var_names(105)="EPLi(iiP3)"
        var_long(105)="Optimal light in P3(PhytoPlankton)"
        var_units(105)="W/m2"
        var_names(106)="EPLi(iiP4)"
        var_long(106)="Optimal light in P4(PhytoPlankton)"
        var_units(106)="W/m2"
  
        var_names(107)="ruPTc"
        var_long(107)="gross primairy production"
        var_units(107)="mg C/m3/d"
        var_names(108)="ruPTn"
        var_long(108)="net nutrient uptake"
        var_units(108)="mmoln /m3/d"
        var_names(109)="ruPTP"
        var_long(109)="net phosphate uptake"
        var_units(109)="mmol P /m3/d"
        var_names(110)="netPP"
        var_long(110)="net primairy production"
        var_units(110)="mg C/m3/d"
        var_names(111)="ruZTc"
        var_long(111)="gross secondairy production"
        var_units(111)="mgC/m3/d"
        var_names(112)="rrPTo"
        var_long(112)="pelagic respiration"
        var_units(112)="mmol O2/m3/d"
        var_names(113)="rePTn"
        var_long(113)="pelagic mineralization"
        var_units(113)="mmol N/m3/d"
        var_names(114)="rePTp"
        var_long(114)="pelagic mineralization"
        var_units(114)="mmol P /m3/d"
        var_names(115)="suPTc"
        var_long(115)="specific gross primairy production"
        var_units(115)="/d"


!
!2d variables descriptions
!

        var_names(116)="Y1c"
        var_long(116)="Epibenthos"
        var_units(116)="mg C/m2"
        var_names(117)="Y1n"
        var_long(117)="Epibenthos"
        var_units(117)="mmol N/m2"
        var_names(118)="Y1p"
        var_long(118)="Epibenthos"
        var_units(118)="mmol P/m2"
        var_names(119)="Y2c"
        var_long(119)="Deposit feeders"
        var_units(119)="mg C/m2"
        var_names(120)="Y2n"
        var_long(120)="Deposit feeders"
        var_units(120)="mmol N/m2"
        var_names(121)="Y2p"
        var_long(121)="Deposit feeders"
        var_units(121)="mmol P/m2"
        var_names(122)="Y3c"
        var_long(122)="Suspension feeders"
        var_units(122)="mg C/m2"
        var_names(123)="Y3n"
        var_long(123)="Suspension feeders"
        var_units(123)="mmol N/m2"
        var_names(124)="Y3p"
        var_long(124)="Suspension feeders"
        var_units(124)="mmol P/m2"
        var_names(125)="Y4c"
        var_long(125)="Meiobenthos"
        var_units(125)="mg C/m2"
        var_names(126)="Y4n"
        var_long(126)="Meiobenthos"
        var_units(126)="mmol N/m2"
        var_names(127)="Y4p"
        var_long(127)="Meiobenthos"
        var_units(127)="mmol P/m2"
        var_names(128)="Y5c"
        var_long(128)="Benthic predators"
        var_units(128)="mg C/m2"
        var_names(129)="Y5n"
        var_long(129)="Benthic predators"
        var_units(129)="mmol N/m2"
        var_names(130)="Y5p"
        var_long(130)="Benthic predators"
        var_units(130)="mmol P/m2"
        var_names(131)="Q6c"
        var_long(131)="Particulate organic carbon"
        var_units(131)="mg C/m2"
        var_names(132)="Q6n"
        var_long(132)="Particulate organic carbon"
        var_units(132)="mmol N/m2"
        var_names(133)="Q6p"
        var_long(133)="Particulate organic carbon"
        var_units(133)="mmol P/m2"
        var_names(134)="Q6s"
        var_long(134)="Particulate organic carbon"
        var_units(134)="mmolSi/m2"
        var_names(135)="Q1c"
        var_long(135)="Labile organic carbon"
        var_units(135)="mg C/m2"
        var_names(136)="Q1n"
        var_long(136)="Labile organic carbon"
        var_units(136)="mmol N/m2"
        var_names(137)="Q1p"
        var_long(137)="Labile organic carbon"
        var_units(137)="mmol P/m2"
        var_names(138)="Q11c"
        var_long(138)="Labile organic carbon"
        var_units(138)="mg C/m2"
        var_names(139)="Q11n"
        var_long(139)="Labile organic carbon"
        var_units(139)="mmol N/m2"
        var_names(140)="Q11p"
        var_long(140)="Labile organic carbon"
        var_units(140)="mmol P/m2"
        var_names(141)="H1c"
        var_long(141)="Aerobic benthic bacteria"
        var_units(141)="mg C/m2"
        var_names(142)="H1n"
        var_long(142)="Aerobic benthic bacteria"
        var_units(142)="mmol N/m2"
        var_names(143)="H1p"
        var_long(143)="Aerobic benthic bacteria"
        var_units(143)="mmol P/m2"
        var_names(144)="H2c"
        var_long(144)="Anaerobic benthic bacteria"
        var_units(144)="mg C/m2"
        var_names(145)="H2n"
        var_long(145)="Anaerobic benthic bacteria"
        var_units(145)="mmol N/m2"
        var_names(146)="H2p"
        var_long(146)="Anaerobic benthic bacteria"
        var_units(146)="mmol P/m2"
        var_names(147)="K1p"
        var_long(147)="Phosphate in oxic layer"
        var_units(147)="mmol P/m3"
        var_names(148)="K11p"
        var_long(148)="Phosphate in denitrification layer"
        var_units(148)="mmol P/m3"
        var_names(149)="K21p"
        var_long(149)="Phosphate in anoxic layer"
        var_units(149)="mmol P/m3"
        var_names(150)="K4n"
        var_long(150)="Ammonium in oxic layer"
        var_units(150)="mmol N/m3"
        var_names(151)="K14n"
        var_long(151)="Ammonium in denitrification layer"
        var_units(151)="mmol N/m3"
        var_names(152)="K24n"
        var_long(152)="Ammonium in anoxic layer"
        var_units(152)="mmol N/m3"
        var_names(153)="K3n"
        var_long(153)="Nitrate in sediments"
        var_units(153)="mmol N/m2"
        var_names(154)="K5s"
        var_long(154)="Silicate in sediments"
        var_units(154)="mmol Si/m2"
        var_names(155)="K6r"
        var_long(155)="Reduction equivalents in sediments"
        var_units(155)="mmolS--/m2"
        var_names(156)="G2o"
        var_long(156)="Benthic O2"
        var_units(156)="mmol O2/m3"
        var_names(157)="G4n"
        var_long(157)="N2 sink for benthic system."
        var_units(157)="mmol N/m3"
        var_names(158)="D1m"
        var_long(158)="Oxygen penetration depth"
        var_units(158)="m"
        var_names(159)="D2m"
        var_long(159)="Denitrification depth"
        var_units(159)="m"
        var_names(160)="D6m"
        var_long(160)="Penetration Depth organic C"
        var_units(160)="m"
        var_names(161)="D7m"
        var_long(161)="Penetration Depth organic N"
        var_units(161)="m"
        var_names(162)="D8m"
        var_long(162)="Penetration Depth organic P"
        var_units(162)="m"
        var_names(163)="D9m"
        var_long(163)="Penetration Depth organic Si"
        var_units(163)="m"
 
        var_names(164)="jOAO2o"
        var_long(164)="oxygen reaeration flux"
        var_units(164)="mmol O2/m2/day"
        var_names(165)="rutQ6c"
        var_long(165)="Total input of R6 to benthos"
        var_units(165)="mg C/m2/d"
        var_names(166)="rutQ6n"
        var_long(166)="Total input of R6 to benthos"
        var_units(166)="mmol N/m2/d"
        var_names(167)="rutQ6p"
        var_long(167)="Total input of R6 to benthos"
        var_units(167)="mmol P/m2/d"
        var_names(168)="rutQ6s"
        var_long(168)="Total input of R6 to benthos"
        var_units(168)="mmol Si/m2/d"
        var_names(169)="rutQ1c"
        var_long(169)="Total input of R1 to benthos"
        var_units(169)="mg C/m2/d"
        var_names(170)="rutQ1n"
        var_long(170)="Total input of R1 to benthos"
        var_units(170)="mmol N/m2/d"
        var_names(171)="rutQ1p"
        var_long(171)="Total input of R1 to benthos"
        var_units(171)="mmol P/m2/d"
        var_names(172)="rrBTo"
        var_long(172)="Total Benthic oxic respiratio"
        var_units(172)="mmol O2/m2/d"
        var_names(173)="rrATo"
        var_long(173)="Total Benthic anoxic respiration"
        var_units(173)="mmol O2/m2/d"
        var_names(174)="reBTn"
        var_long(174)="Total Benthic oxic respiratio"
        var_units(174)="mmol N/m2/d"
        var_names(175)="reBTp"
        var_long(175)="Total Benthic oxic respiratio"
        var_units(175)="mmol P/m2/d"
        var_names(176)="reATn"
        var_long(176)="Total Benthic anoxic respiration"
        var_units(176)="mmol N/m2/d"
        var_names(177)="reATp"
        var_long(177)="Total Benthic anoxic respiration"
        var_units(177)="mmol P/m2/d"
        var_names(178)="turenh"
        var_long(178)="Enhancement factor due to bioirrigation"
        var_units(178)="-"
        var_names(179)="irrenh"
        var_long(179)="Enhancement factor due to bioturbation"
        var_units(179)="-"
        var_names(180)="shiftD1m"
        var_long(180)="Rate of change of D1m"
        var_units(180)="m/d"
        var_names(181)="shiftD2m"
        var_long(181)="Rate of change of D2m"
        var_units(181)="m/d"
        var_names(182)="jG2K3o"
        var_long(182)="Oxygen consumption by nitrification."
        var_units(182)="mmol O2/m2/d"
        var_names(183)="jG2K7o"
        var_long(183)="ReOxidation of Red.Equiv. in  oxic layer"
        var_units(183)="mmol S--/m2/d"
        var_names(184)="M1p"
        var_long(184)="phosphate in oxic layer"
        var_units(184)="mmol P/m3"
        var_names(185)="M11p"
        var_long(185)="phosphate in denitrification layer"
        var_units(185)="mmol P/m3"
        var_names(186)="M21p"
        var_long(186)="phosphate in anoxic layer"
        var_units(186)="mmol P/m3"
        var_names(187)="M4n"
        var_long(187)="ammonium in oxic layer"
        var_units(187)="mmol N/m3"
        var_names(188)="M14n"
        var_long(188)="ammonium in denitrification layer"
        var_units(188)="mmol N/m3"
        var_names(189)="M24n"
        var_long(189)="ammonium in anoxic layer"
        var_units(189)="mmol N/m3"
        var_names(190)="M3n"
        var_long(190)="nitrate in porewater"
        var_units(190)="mmol N/m3"
        var_names(191)="M5s"
        var_long(191)="silicate in oxic_denitrification layer"
        var_units(191)="mmol Si/m3"
        var_names(192)="M6r"
        var_long(192)="reduction equivalent in porewater"
        var_units(192)="mmol S--/m3"
        var_names(193)="RIc"
        var_long(193)="Detritus Food for Filterfeeder"
        var_units(193)="mg C/m3"
        var_names(194)="RIn"
        var_long(194)="Detritus Food for Filterfeeder"
        var_units(194)="mmol N /m3"
        var_names(195)="RIp"
        var_long(195)="Detritus Food for Filterfeeder"
        var_units(195)="mmol N/m3"
        var_names(196)="RIs"
        var_long(196)="Detritus Food for Filterfeeder"
        var_units(196)="mmol Si/m3"
        var_names(197)="PIc"
        var_long(197)="Total phytoplankton Food"
        var_units(197)="mg C/m3"
        var_names(198)="PIn"
        var_long(198)="Total phytoplankton Food"
        var_units(198)="mmol N /m3"
        var_names(199)="PIp"
        var_long(199)="Total phytoplankton Food"
        var_units(199)="mmol N/m3"
        var_names(200)="PIs"
        var_long(200)="Total phytoplankton Food"
        var_units(200)="mmol Si/m3"
        var_names(201)="jPIY3c"
        var_long(201)="phytoplankton filtered by filter feeders"
        var_units(201)="mg C/m2/d"
        var_names(202)="jRIY3c"
        var_long(202)="detrtus filtered by filter feeders"
        var_units(202)="mg C/m2/d"
        var_names(203)="jRIY3n"
        var_long(203)="detrtus filtered by filter feeders"
        var_units(203)="mmol N/m2/d"
        var_names(204)="jRIY3p"
        var_long(204)="detrtus filtered by filter feeders"
        var_units(204)="mmol P/m2/d"
        var_names(205)="jRIY3s"
        var_long(205)="detrtus filtered by filter feeders"
        var_units(205)="mmol Si/m2/d"
        var_names(206)="Depth_Ben"
        var_long(206)="depth of the  layer above sediment"
        var_units(206)="m"
        var_names(207)="ETW_Ben"
        var_long(207)="temperature"
        var_units(207)="C"
        var_names(208)="O2o_Ben"
        var_long(208)="oxygen conc. in the pelagica"
        var_units(208)="mmol O2/m3"
        var_names(209)="N1p_Ben"
        var_long(209)="phosphate conc. in the pelagic"
        var_units(209)="mmol P/m3"
        var_names(210)="N3n_Ben"
        var_long(210)="nitrate conc. in the pelagic"
        var_units(210)="mmol N/m3"
        var_names(211)="N4n_Ben"
        var_long(211)="ammonium conc. in the pelagic"
        var_units(211)="mmol N/m3"
        var_names(212)="N5s_Ben"
        var_long(212)="silicate conc. in the pelagic"
        var_units(212)="mmol Si/m3"
        var_names(213)="N6r_Ben"
        var_long(213)="red. equiv. conc. in the pelagic"
        var_units(213)="mmol S--/m3"
        var_names(214)="jG2O2o"
        var_long(214)="flux of oxygen from sediment to pelagic"
        var_units(214)="mmol/m2/d"
        var_names(215)="jK1N1p"
        var_long(215)="flux of phosphate from sediment to pelagic"
        var_units(215)="mmol/m2/d"
        var_names(216)="jK3N3n"
        var_long(216)="flux of nitrate from sediment to pelagic"
        var_units(216)="mmol/m2/d"
        var_names(217)="jK4N4n"
        var_long(217)="flux of ammonium from sediment to pelagic"
        var_units(217)="mmol/m2/d"
        var_names(218)="jK5N5s"
        var_long(218)="flux of silicate from sediment to pelagic"
        var_units(218)="mmol/m2/d"
        var_names(219)="jK6N6r"
        var_long(219)="flux of red. equiv. from sediment to pelagic"
        var_units(219)="mmol/m2/d"
        var_names(220)="totpeln"
        var_long(220)="total mass present in pelagic"
        var_units(220)="mmol N/m3"
        var_names(221)="totpelp"
        var_long(221)="total mass present in pelagic"
        var_units(221)="mmol P/m3"
        var_names(222)="totpels"
        var_long(222)="total mass present in pelagic"
        var_units(222)="mmol Si/m3"
        var_names(223)="totbenn"
        var_long(223)="total mass present in benthos"
        var_units(223)="mmol N/m3"
        var_names(224)="totbenp"
        var_long(224)="total mass present in benthos"
        var_units(224)="mmol P/m3"
        var_names(225)="totbens"
        var_long(225)="total mass present in benthos"
        var_units(225)="mmol Si/m3"
  
        var_names(226)="ruHI(iiH1)"
        var_long(226)="uptake of Q1/Q11 by H1(BenBacteria)"
        var_units(226)="mg C/m2/d"
        var_names(227)="ruHI(iiH2)"
        var_long(227)="uptake of Q1/Q11 by H2(BenBacteria)"
        var_units(227)="mg C/m2/d"
        var_names(228)="reHI(iiH1)"
        var_long(228)="excretion of Q1/Q11 H1(BenBacteria)"
        var_units(228)="mg C/m2/d"
        var_names(229)="reHI(iiH2)"
        var_long(229)="excretion of Q1/Q11 H2(BenBacteria)"
        var_units(229)="mg C/m2/d"
        var_names(230)="retPIc(iiP1)"
        var_long(230)="P1(PhytoPlankton) uptaken by filter feeders"
        var_units(230)="mg C/m2/d"
        var_names(231)="retPIc(iiP2)"
        var_long(231)="P2(PhytoPlankton) uptaken by filter feeders"
        var_units(231)="mg C/m2/d"
        var_names(232)="retPIc(iiP3)"
        var_long(232)="P3(PhytoPlankton) uptaken by filter feeders"
        var_units(232)="mg C/m2/d"
        var_names(233)="retPIc(iiP4)"
        var_long(233)="P4(PhytoPlankton) uptaken by filter feeders"
        var_units(233)="mg C/m2/d"
        var_names(234)="retPIn(iiP1)"
        var_long(234)="P1(PhytoPlankton) uptaken by filter feeders"
        var_units(234)="mmol N/m2/d"
        var_names(235)="retPIn(iiP2)"
        var_long(235)="P2(PhytoPlankton) uptaken by filter feeders"
        var_units(235)="mmol N/m2/d"
        var_names(236)="retPIn(iiP3)"
        var_long(236)="P3(PhytoPlankton) uptaken by filter feeders"
        var_units(236)="mmol N/m2/d"
        var_names(237)="retPIn(iiP4)"
        var_long(237)="P4(PhytoPlankton) uptaken by filter feeders"
        var_units(237)="mmol N/m2/d"
        var_names(238)="retPIp(iiP1)"
        var_long(238)="P1(PhytoPlankton) uptaken by filter feeders"
        var_units(238)="mmol P/m2/d"
        var_names(239)="retPIp(iiP2)"
        var_long(239)="P2(PhytoPlankton) uptaken by filter feeders"
        var_units(239)="mmol P/m2/d"
        var_names(240)="retPIp(iiP3)"
        var_long(240)="P3(PhytoPlankton) uptaken by filter feeders"
        var_units(240)="mmol P/m2/d"
        var_names(241)="retPIp(iiP4)"
        var_long(241)="P4(PhytoPlankton) uptaken by filter feeders"
        var_units(241)="mmol P/m2/d"
        var_names(242)="retPIl(iiP1)"
        var_long(242)="P1(PhytoPlankton) uptaken by filter feeders"
        var_units(242)="mmol Si/m2/d"
        var_names(243)="retPIl(iiP2)"
        var_long(243)="P2(PhytoPlankton) uptaken by filter feeders"
        var_units(243)="mmol Si/m2/d"
        var_names(244)="retPIl(iiP3)"
        var_long(244)="P3(PhytoPlankton) uptaken by filter feeders"
        var_units(244)="mmol Si/m2/d"
        var_names(245)="retPIl(iiP4)"
        var_long(245)="P4(PhytoPlankton) uptaken by filter feeders"
        var_units(245)="mmol Si/m2/d"
        var_names(246)="retPIs(iiP1)"
        var_long(246)="P1(PhytoPlankton) uptaken by filter feeders"
        var_units(246)="mg Chl /m2/d"
        var_names(247)="retPIs(iiP2)"
        var_long(247)="P2(PhytoPlankton) uptaken by filter feeders"
        var_units(247)="mg Chl /m2/d"
        var_names(248)="retPIs(iiP3)"
        var_long(248)="P3(PhytoPlankton) uptaken by filter feeders"
        var_units(248)="mg Chl /m2/d"
        var_names(249)="retPIs(iiP4)"
        var_long(249)="P4(PhytoPlankton) uptaken by filter feeders"
        var_units(249)="mg Chl /m2/d"
  
        var_names(250)="netPPm2"
        var_long(250)="net primairy production"
        var_units(250)="mg C/m2/d"


        stPelStateS=1
        stPelStateE=48
        stPelDiagS=49
        stPelDiagE=106
        stPelFluxS=107
        stPelFluxE=115
        stBenStateS=116
        stBenStateE=163
        stBenDiagS=164
        stBenDiagE=249
        stBenFluxS=250
        stBenFluxE=250


end subroutine set_var_info_bfm
